#include "SRAnimatedAmmoSprite.h"
#include "SRGraphicsUtils.h"

SRAnimatedAmmoSprite::SRAnimatedAmmoSprite( CFStringRef inBasename, int inNumIcons,
                      int inFramesPerIcon, SRObject *inParent )
    : SRAmmoSprite(0, inParent), fCurrentFrame(0), fNumFrames(inNumIcons),
      fFramesPerIcon(inFramesPerIcon), fFrameCounter(inFramesPerIcon)
{
    // for each frame ID, create a CIconHandle, and add it to the
    // list
    fImages = new CGImageRef[fNumFrames];
    
    SRGraphicsUtils::CreateCGImagesForFramedResourcesNamed( inBasename, fImages, fNumFrames );
	
	fImage = fImages[0];
}

SRAnimatedAmmoSprite::~SRAnimatedAmmoSprite()
{
    int i;
    for( i=0; i<fNumFrames; i++ )
    {
        if( i != fCurrentFrame )
            CGImageRelease( fImages[i] );
    }
    
    delete [] fImages;
}

void
SRAnimatedAmmoSprite::Think()
{
    if( fFrameCounter == 0 )
    {
        fCurrentFrame++;
        
        if( fCurrentFrame == fNumFrames ) fCurrentFrame = 0;
        
        fImage = fImages[fCurrentFrame];
        fFrameCounter = fFramesPerIcon;
    }
    
    fFrameCounter--;
    
	// Call up
	SRAmmoSprite::Think();
}
