#ifndef __SR_OBJECT_H__
#define __SR_OBJECT_H__

class SRObject
{
// constructor/destructor
protected:
    SRObject();

// tick methods
public:
    virtual ~SRObject();
    virtual void Think() = 0;
    void Move();
    virtual void Draw( CGContextRef theRef ) = 0;
    virtual bool Hit( SRObject *other ) = 0;
    virtual int Type() = 0;
    virtual void ChildDied( SRObject * ) {}
    virtual bool WantsCollisions() { return false; }
    
// accessors
public:
    // the position is the middle of the sprite
    float xPosition() { return fX; }
    float yPosition() { return fY; }
    float xVelocity() { return fVelocityX; }
    float yVelocity() { return fVelocityY; }
    float width() { return fWidth; }
    float height() { return fHeight; }

// low-level mutators
public:
    void setX( float x ) { fX = x; }
    void setY( float y ) { fY = y; }

// high-level mutators
public:
    void pushX( float force ) { fVelocityX += force; }
    void pushY( float force ) { fVelocityY += force; }
    void push( float x, float y ) { pushX(x); pushY(y); }

// Data members
protected:
    // dimensions
    float fWidth;
    float fHeight;

    //position
    float fX;
    float fY;
    
    // velocity
    float fVelocityX;
    float fVelocityY;
    
    // acceleration
    float fAccelX;
    float fAccelY;
    
    SRObject *fParent;
};

#endif //__SR_OBJECT_H__
