#ifndef __SR_OBJECT_LIST_H__
#define __SR_OBJECT_LIST_H__

#include "SRObject.h"

//#include <fstream>
class FileWrapper;

#define     kStartingSize       30
#define     kGrowSize           5

class SRObjectList
{
    class ListItem
    {
    public:
        SRObject *object;
        //ListItem *next;
        bool      marked;
    };

public:
    class Iterator
    {
    public:
        Iterator(ListItem *list, int numItems);
        //Iterator(ListItem *first);
        ~Iterator() {}
        
        // returns the current item, and moves to the next
        SRObject *next();
        // sets the current item to the first
        void reset();
    private:
/*  Old implementation
        ListItem *fFirst;
        ListItem *fCurrent;
        */
        ListItem *fList;
        int       fCurrentIndex;
        int       fNumItems;
    };

public:
    SRObjectList(bool log = false, bool fullClean = false);
    ~SRObjectList();
    
    void printList();

public:
    Iterator *NewIterator();
    
    void add( SRObject *item );
    void remove( SRObject *item );
    void clean();

private:
    ListItem *fArray;
/*  Old implementation
    ListItem *fFirst;
    ListItem *fLast;
    ListItem *fCurrent;
    */
    int       fNumItems;
    int       fCurrentSize;
    bool      fFullClean;
//    ofstream  fOutFile;
    FileWrapper *dlog;
};

#endif // __SR_OBJECT_LIST_H__
