#ifndef __SR_PLAYER_SPRITE__
#define __SR_PLAYER_SPRITE__

#include "SRCgImageSprite.h"
#include "SRObjectList.h"
#include "SRObjectTypes.h"

#define kLeftIcon             0
#define kRightIcon            2
#define kStationaryIcon       1

#define kAmmoIcon             3

#define kAmmoForce            5.0f
#define kAmmoDistance         24.0f
#define kAmmoCountdown        20

#define kBoundary             24
#define kZone                 64

class SRPlayerSprite : public SRCgImageSprite
{
public:
    enum Command
    {
        DirectionRight,
        DirectionLeft,
        DirectionUp,
        DirectionDown,
        DirectionHalt,
        WeaponFire
    };

public:
    SRPlayerSprite();
    ~SRPlayerSprite();

public:
   static SRPlayerSprite *instance() { return fInstance; }
    
    void TakeCommand( Command theCommand );
    
    virtual void Think();
    virtual bool Hit( SRObject *other );
    
    virtual void ChildDied( SRObject *ammo );
    
    virtual int Type() { return kPlayerType; }
    
    void ResetPosition();

protected:
    static SRPlayerSprite  *fInstance;

//    CIconHandle             fAmmoIcon;
    
//    CIconHandle             fLeftIcon;
//    CIconHandle             fRightIcon;
//    CIconHandle             fStationaryIcon;
    
	CGImageRef				fLeftImage;
	CGImageRef				fRightImage;
	CGImageRef				fStationaryImage;
	
    bool                    fFireNow;
    Command                 fDirection;
    int                     fAmmoTimer;
    
    //SRObjectList           *fAmmo;
};

#endif // __SR_PLAYER_SPRITE__
