#ifndef __SR_SOUND_MANAGER__
#define __SR_SOUND_MANAGER__

#define kMusicWaitTime      1500

class SRSoundManager
{
public:
    enum SoundEffect
    {
        SFXboom,
        SFXplayerHit,
        SFXplayerFires,
        SFXammoBoom,
        
        SFXnum
    };
    
    enum Music
    {
        MUSpeaceful,
        MUSaggravated,
        MUSmournful,
        
        MUSnum
    };

public:
    static void InitSound();
    static void EndSound();
    
    static void PlaySoundEffect( SoundEffect effect );
    static void PauseSoundEffects();
    static void ResumeSoundEffects();
    static void EndSoundEffects();
    
    static void SetMusic( Music music );
    static void MusicIdle();
    static void PauseMusic();
    static void ResumeMusic();
    static void StartMusic();
    static void EndMusic();
    static pascal void MusicCallBack(SndChannelPtr chan,SndCommand *);
    
    static bool IsPlaying() { return fMusicOn; }
    static void TogglePlaying();
    
    static bool AreFXOn() { return fFXOn; }
    static void ToggleFX();

private:
    static SndChannelPtr   fSoundEffectsChannelOne;
    static SndChannelPtr   fSoundEffectsChannelTwo;
    static SndChannelPtr   fSoundEffectsChannel;
    static SndChannelPtr   fMusicChannel;
    static SndListHandle   *fSFXArray;
    static SndListHandle   *fMUSArray;
    
    static Music           fCurrentMusic;
    static bool            fMusicIsPlaying;
    static bool            fMusicOn;
    static bool            fFXOn;
};

#endif // __SR_SOUND_MANAGER__
